'*******************************************************************************
'GasLog v1.1.0
'********************************************************************************
'2006.10.01
'
'http://supware.net
'doug@supware.net
'
'Copyright (C) 2005-2006 Doug Melton
'
'This program is free software; you can redistribute it and/or
'modify it under the terms of the GNU General Public License
'as published by the Free Software Foundation; either version 2
'of the License, or (at your option) any later version.
'
'This program is distributed in the hope that it will be useful,
'but WITHOUT ANY WARRANTY; without even the implied warranty of
'MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details.
'
'You should have received a copy of the GNU General Public License
'along with this program; if not, write to the Free Software
'Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
'

Public Class frmBlueTunes
    Inherits System.Windows.Forms.Form
    Friend WithEvents mnuOptions As System.Windows.Forms.MenuItem
    Friend WithEvents mnuMain As System.Windows.Forms.MainMenu

    Private cdialProcess As Process

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

        Me.RefreshStatus()
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        MyBase.Dispose(disposing)
    End Sub

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents lblCdial As System.Windows.Forms.Label
    Friend WithEvents lblStatus As System.Windows.Forms.Label
    Friend WithEvents mnuToggle As System.Windows.Forms.MenuItem
    Friend WithEvents mnuAbout As System.Windows.Forms.MenuItem
    Friend WithEvents MenuExit As System.Windows.Forms.MenuItem
    Friend WithEvents mnuRefresh As System.Windows.Forms.MenuItem
    Friend WithEvents MenuSeparator As System.Windows.Forms.MenuItem
    Private Sub InitializeComponent()
        Me.mnuMain = New System.Windows.Forms.MainMenu
        Me.mnuToggle = New System.Windows.Forms.MenuItem
        Me.mnuOptions = New System.Windows.Forms.MenuItem
        Me.mnuRefresh = New System.Windows.Forms.MenuItem
        Me.MenuSeparator = New System.Windows.Forms.MenuItem
        Me.mnuAbout = New System.Windows.Forms.MenuItem
        Me.MenuExit = New System.Windows.Forms.MenuItem
        Me.lblCdial = New System.Windows.Forms.Label
        Me.lblStatus = New System.Windows.Forms.Label
        '
        'mnuMain
        '
        Me.mnuMain.MenuItems.Add(Me.mnuToggle)
        Me.mnuMain.MenuItems.Add(Me.mnuOptions)
        '
        'mnuToggle
        '
        Me.mnuToggle.Text = "Toggle"
        '
        'mnuOptions
        '
        Me.mnuOptions.MenuItems.Add(Me.mnuRefresh)
        Me.mnuOptions.MenuItems.Add(Me.MenuSeparator)
        Me.mnuOptions.MenuItems.Add(Me.mnuAbout)
        Me.mnuOptions.MenuItems.Add(Me.MenuExit)
        Me.mnuOptions.Text = "Options"
        '
        'mnuRefresh
        '
        Me.mnuRefresh.Text = "Refresh"
        '
        'MenuSeparator
        '
        Me.MenuSeparator.Text = "-"
        '
        'mnuAbout
        '
        Me.mnuAbout.Text = "About..."
        '
        'MenuExit
        '
        Me.MenuExit.Text = "Exit"
        '
        'lblCdial
        '
        Me.lblCdial.Location = New System.Drawing.Point(24, 16)
        Me.lblCdial.Size = New System.Drawing.Size(88, 22)
        Me.lblCdial.Text = "bluetunes:"
        '
        'lblStatus
        '
        Me.lblStatus.Location = New System.Drawing.Point(48, 48)
        Me.lblStatus.Size = New System.Drawing.Size(104, 22)
        Me.lblStatus.Text = "Label1"
        '
        'frmBlueTunes
        '
        Me.Controls.Add(Me.lblStatus)
        Me.Controls.Add(Me.lblCdial)
        Me.Menu = Me.mnuMain
        Me.Text = "BlueTunes"

    End Sub

#End Region

#Region " Menu items "

    Private Sub mnuToggle_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuToggle.Click
        If cdialProcess Is Nothing Then
            Execute.ShellExecute("\windows\cdial.exe")
        Else
            cdialProcess.Kill()
        End If

        RefreshStatus()
    End Sub

    Private Sub mnuRefresh_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuRefresh.Click
        RefreshStatus()
    End Sub

    Private Sub mnuAbout_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles mnuAbout.Click
        Dim crlf As String = Chr(13) + Chr(10)
        MessageBox.Show( _
            "BlueTunes" + crlf _
            + "Version 1.1.0" + crlf _
            + crlf _
            + "by Doug Melton" + crlf _
            + "2006.10.01" + crlf _
            + crlf _
            + "http://supware.net", _
            "About BlueTunes" _
        )
    End Sub

    Private Sub MenuExit_Click(ByVal sender As System.Object, _
        ByVal e As System.EventArgs) Handles MenuExit.Click
        Application.Exit()
    End Sub

#End Region

    Private Sub RefreshStatus()
        cdialProcess = Process.GetCdial

        If cdialProcess Is Nothing Then
            Me.lblStatus.ForeColor = System.Drawing.Color.ForestGreen
            Me.lblStatus.Text = "enabled"
            Me.mnuToggle.Text = "Disable"
        Else
            Me.lblStatus.ForeColor = System.Drawing.Color.Red
            Me.lblStatus.Text = "disabled"
            Me.mnuToggle.Text = "Enable"
        End If
    End Sub

End Class

Public Class PROCESSENTRY32
    ' constants for structure definition
    Private Const SizeOffset As Integer = 0
    Private Const UsageOffset As Integer = 4
    Private Const ProcessIDOffset As Integer = 8
    Private Const DefaultHeapIDOffset As Integer = 12
    Private Const ModuleIDOffset As Integer = 16
    Private Const ThreadsOffset As Integer = 20
    Private Const ParentProcessIDOffset As Integer = 24
    Private Const PriClassBaseOffset As Integer = 28
    Private Const dwFlagsOffset As Integer = 32
    Private Const ExeFileOffset As Integer = 36
    Private Const MemoryBaseOffset As Integer = 556
    Private Const AccessKeyOffset As Integer = 560
    Private Const Size As Integer = 564 ' the whole size of the structure
    Private Const MAX_PATH As Integer = 260

    ' data members
    Public dwSize As Long
    Public cntUsage As Long
    Public th32ProcessID As Long
    Public th32DefaultHeapID As Long
    Public th32ModuleID As Long
    Public cntThreads As Long
    Public th32ParentProcessID As Long
    Public pcPriClassBase As Long
    Public dwFlags As Long
    Public szExeFile As String
    Public th32MemoryBase As Long
    Public th32AccessKey As Long

    ' utility:  get a uint from the byte array
    Private Shared Function GetUInt(ByRef aData() As Byte, ByVal Offset As Integer) As UInt32
        Return BitConverter.ToUInt32(aData, Offset)
    End Function

    Private Shared Function GetLong(ByRef aData() As Byte, ByVal Offset As Integer) As Long
        Return BitConverter.ToInt32(aData, Offset)
    End Function

    ' utility:  set a uint into the byte array
    Private Shared Sub SetUInt(ByRef aData() As Byte, ByVal Offset As Integer, ByVal Value As Integer)
        Dim buint() As Byte = BitConverter.GetBytes(Value)
        Buffer.BlockCopy(buint, 0, aData, Offset, buint.Length)
    End Sub

    ' utility:  get a ushort from the byte array
    Private Shared Function GetUShort(ByRef aData() As Byte, ByVal Offset As Integer) As UInt16
        Return BitConverter.ToUInt16(aData, Offset)
    End Function

    ' utility:  set a ushort int the byte array
    Private Shared Sub SetUShort(ByRef aData() As Byte, ByVal Offset As Integer, ByVal Value As Integer)
        Dim bushort() As Byte = BitConverter.GetBytes(System.Convert.ToInt16(Value))
        Buffer.BlockCopy(bushort, 0, aData, Offset, bushort.Length)
    End Sub

    ' utility:  get a unicode string from the byte array
    Private Shared Function GetString(ByRef aData() As Byte, ByVal Offset As Integer, ByVal Length As Integer) As String
        Dim sReturn As String = System.Text.Encoding.Unicode.GetString(aData, Offset, Length)
        Return sReturn
    End Function

    ' utility:  set a unicode string in the byte array
    Private Shared Sub SetString(ByRef aData() As Byte, ByVal Offset As Integer, ByVal Value As String)
        Dim arr() As Byte = System.Text.Encoding.ASCII.GetBytes(Value)
        Buffer.BlockCopy(arr, 0, aData, Offset, arr.Length)
    End Sub

    ' create a PROCESSENTRY instance based on a byte array      
    Public Sub New(ByRef aData() As Byte)
        Me.dwSize = GetLong(aData, SizeOffset)
        Me.cntUsage = GetLong(aData, UsageOffset)
        Me.th32ProcessID = GetLong(aData, ProcessIDOffset)
        Me.th32DefaultHeapID = GetLong(aData, DefaultHeapIDOffset)
        Me.th32ModuleID = GetLong(aData, ModuleIDOffset)
        Me.cntThreads = GetLong(aData, ThreadsOffset)
        Me.th32ParentProcessID = GetLong(aData, ParentProcessIDOffset)
        Me.pcPriClassBase = GetLong(aData, PriClassBaseOffset)
        Me.dwFlags = GetLong(aData, dwFlagsOffset)
        Me.szExeFile = GetString(aData, ExeFileOffset, MAX_PATH)
        Me.th32MemoryBase = GetLong(aData, MemoryBaseOffset)
        Me.th32AccessKey = GetLong(aData, AccessKeyOffset)
    End Sub

    Public Sub New()
    End Sub

    ' create an initialized data array
    Public Function ToByteArray() As Byte()
        Dim aData(Size) As Byte
        ' set the Size member
        SetUInt(aData, SizeOffset, Size)
        Return aData
    End Function

    Public Function Name() As String
        Return szExeFile.Substring(0, szExeFile.IndexOf("\0"))
    End Function

    Public Function PID() As Long
        Return System.Convert.ToInt64(th32ProcessID)
    End Function

    Public Function BaseAddress() As Long
        Return th32MemoryBase
    End Function

    Public Function ThreadCount() As Long
        Return System.Convert.ToInt64(cntThreads)
    End Function

    Public Const TH32CS_SNAPPROCESS As Integer = 2

    Overloads Declare Function CreateToolhelp32Snapshot Lib "toolhelp.dll" (ByVal flags As Integer, ByVal processid As Integer) As IntPtr
    Overloads Declare Function CloseToolhelp32Snapshot Lib "toolhelp.dll" (ByVal handle As IntPtr) As Integer
    Overloads Declare Function Process32First Lib "toolhelp.dll" (ByVal handle As IntPtr, ByVal pe() As Byte) As Integer
    Overloads Declare Function Process32Next Lib "toolhelp.dll" (ByVal handle As IntPtr, ByVal pe() As Byte) As Integer

    Overloads Declare Function OpenProcess Lib "coredll.dll" (ByVal flags As Integer, ByVal fInherit As Boolean, ByVal PID As Integer) As IntPtr

    Public Const PROCESS_TERMINATE As Integer = 1
    Overloads Declare Function TerminateProcess Lib "coredll.dll" (ByVal hProcess As IntPtr, ByVal ExitCode As UInt32) As Boolean

    Overloads Declare Function CloseHandle Lib "coredll.dll" (ByVal handle As IntPtr) As Boolean
    Private Const INVALID_HANDLE_VALUE As Integer = -1
End Class

Public Class Process
    Private processName As String
    Private handle As Long
    Private threadCount As Integer
    Private baseAddress As Long

    'default constructor
    Public Sub New()
    End Sub

    'private helper constructor
    Private Sub New(ByVal id As Long, ByVal procname As String, ByVal threadcount As Integer, ByVal baseaddress As Long)
        Me.handle = id
        Me.processName = procname
        Me.threadCount = threadcount
        Me.baseAddress = baseaddress
    End Sub

    Public Shared Function GetCdial() As Process

        Dim cdialProc As Process

        'temp ArrayList
        Dim handle As IntPtr = PROCESSENTRY32.CreateToolhelp32Snapshot(PROCESSENTRY32.TH32CS_SNAPPROCESS, 0)

        If handle.ToInt32 > 0 Then
            Try
                Dim peCurrent As PROCESSENTRY32
                Dim pe32 As PROCESSENTRY32 = New PROCESSENTRY32
                'Get byte array to pass to the API calls
                Dim peBytes() As Byte = pe32.ToByteArray()
                'Get the first process
                Dim retval As Integer = PROCESSENTRY32.Process32First(handle, peBytes)
                While retval = 1 And cdialProc Is Nothing
                    'Convert bytes to the class
                    peCurrent = New PROCESSENTRY32(peBytes)

                    If peCurrent.Name.Substring(0, 9).Equals("cdial.exe") Then
                        cdialProc = New Process(peCurrent.PID, peCurrent.Name, peCurrent.ThreadCount, peCurrent.BaseAddress)
                    End If

                    retval = PROCESSENTRY32.Process32Next(handle, peBytes)
                End While
            Catch ex As Exception
                Throw New Exception("Exception: " + ex.Message)
            End Try

            'Close handle
            PROCESSENTRY32.CloseToolhelp32Snapshot(handle)

            Return cdialProc
        Else
            Throw New Exception("Unable to create snapshot")
        End If
    End Function

    Public Overrides Function ToString() As String
        Return Me.processName
    End Function

    Public Function getHandle() As Long
        Return Me.handle
    End Function

    Public Function getProcessName() As String
        Return Me.processName
    End Function

    Public Function getThreadCount() As Integer
        Return Me.threadCount
    End Function

    Public Function getBaseAddress() As Long
        Return Me.baseAddress
    End Function

    Public Function Kill() As Boolean
        Dim hwnd As IntPtr = PROCESSENTRY32.OpenProcess(0, False, Me.handle)
        Return PROCESSENTRY32.TerminateProcess(hwnd, System.Convert.ToUInt32(0))
    End Function
End Class

Class Execute
    Class SXX
        Public cbSize As Int32
        Public fMask As Int32
        Public hwnd As IntPtr
        Public lpVerb As IntPtr
        Public lpFile As IntPtr
        Public lpParameters As IntPtr
        Public lpDirectory As IntPtr

        Public nShow As Integer
        Public hInstApp As IntPtr
        ' Optional members
        Public lpIDList As IntPtr
        Public lpClass As IntPtr
        Public hkeyClass As IntPtr
        Public dwHotKey As Int32
        Public hIcon As IntPtr
        Public hProcess As IntPtr
    End Class 'SXX

    Overloads Declare Function ShellExecuteEx Lib "CoreDll.dll" (ByVal ex As SXX) As Integer
    Overloads Declare Function LocalAlloc Lib "CoreDll.dll" (ByVal flags As Integer, ByVal size As Integer) As IntPtr
    Overloads Declare Function LocalFree Lib "CoreDll.dll" (ByVal ptr As IntPtr)

    Public Overloads Shared Function ShellExecute(ByVal program As String)
        ' Code starts here
        Dim docname As String = program
        Dim nSize As Integer = docname.Length * 2 + 2
        Dim pData As IntPtr = LocalAlloc(&H40, nSize)
        System.Runtime.InteropServices.Marshal.Copy(System.Text.Encoding.Unicode.GetBytes(docname), 0, pData, nSize - 2)

        Dim see As New SXX
        see.cbSize = 60
        see.dwHotKey = 0
        see.fMask = 0
        see.hIcon = IntPtr.Zero
        see.hInstApp = IntPtr.Zero
        see.hProcess = IntPtr.Zero
        see.lpClass = IntPtr.Zero
        see.lpDirectory = IntPtr.Zero
        see.lpIDList = IntPtr.Zero
        see.lpParameters = IntPtr.Zero
        see.lpVerb = IntPtr.Zero
        see.nShow = 0
        see.lpFile = pData

        ShellExecuteEx(see)
        'LocalFree(pData) ' why doesn't this work? "NotSupportedException"
    End Function
End Class